#!/bin/bash

WIRELESS_INTERFACE=`cat /proc/net/wireless | tail -n+3 | awk '{print substr($1, 1, length($1)-1)}'`

check_inet()
{
    local inet_filename=`dirname $0`/internet.ok

    rm -f ${inet_filename}
    while true
    do                    # google dns                           # open dns                                    # chinese dns
        if ping -c 1 -W 2 8.8.8.8 &> /dev/null || ping -c 1 -W 2 208.67.222.222 &> /dev/null || ping -c 1 -W 2 1.2.4.8 &> /dev/null
        then
            touch ${inet_filename}
        else
            rm -f ${inet_filename}
        fi
        sleep 25
    done &
}

wifi_ip_lost_patch_pings_cbox_every_2_seconds_remove_me_after_federico_fix()
{
    while true
    do
        ping -c 1 -W 2 10.1.2.1 &> /dev/null
        sleep 2
    done &
}

check_iwfaces_not_present()
{
    test -z ${WIRELESS_INTERFACE}
    return $?
}

check_inet
wifi_ip_lost_patch_pings_cbox_every_2_seconds_remove_me_after_federico_fix

wireless_pid=0

while true
do
    # test if no wifi capability present
    # note, that 0 is success code for /bin/sh, while 1 is error
    if check_iwfaces_not_present
    then
        # kill dhcpd of eth1 if present
        if ps -p ${wireless_pid} &> /dev/null
        then
            kill -9 ${wireless_pid} &> /dev/null
        fi
        wireless_pid=0

        # start dhcpcd on usb0
        dhcpcd -t 0 -b usb0 &> /dev/null
    else
        # start dhcpcd on eth1
        dhcpcd -t 0 -b ${WIRELESS_INTERFACE} &> /dev/null
        wireless_pid=$!

        # wait until usb0 is connected or when wifi disappears
        while ! ifconfig usb0 &> /dev/null && ! check_iwfaces_not_present
        do
            sleep 1
        done

        if ifconfig usb0 &> /dev/null
        then
            # setup static ip and route for usb0
            ifconfig usb0 10.1.2.251 netmask 255.0.0.0 up &> /dev/null
            route add 239.1.1.1 dev usb0 &> /dev/null
        fi
    fi

    sleep 5
done &
